var MovablePoint = (function () {
    function MovablePoint(ctx, x, y, name) {
        this.ctx = ctx;
        this.x = x;
        this.y = y;
        this.name = name;
        this.isDragging = false;
    }
    MovablePoint.prototype.getX = function () { return this.x; };
    MovablePoint.prototype.getY = function () { return this.y; };
    MovablePoint.prototype.setX = function (v) { this.x = v; };
    MovablePoint.prototype.setY = function (v) { this.y = v; };
    MovablePoint.prototype.draw = function () {
        this.ctx.fillStyle = "#555555";
        this.ctx.fillRect(this.x - MovablePoint.WIDTH_HALF, this.y - MovablePoint.WIDTH_HALF, 2 * MovablePoint.WIDTH_HALF, 2 * MovablePoint.WIDTH_HALF);
        if (this.name) {
            this.ctx.save();
            this.ctx.font = '12px Roboto';
            this.ctx.strokeText(this.name + " (" + this.x + ", " + this.y + ")", this.x + 2 * MovablePoint.WIDTH_HALF, this.y - 2 * MovablePoint.WIDTH_HALF);
            this.ctx.restore();
        }
    };
    MovablePoint.prototype.isCursorOnPoint = function (cursorX, cursorY) {
        if ((cursorX >= this.x - MovablePoint.WIDTH_HALF) && (cursorX <= this.x + MovablePoint.WIDTH_HALF) &&
            (cursorY >= this.y - MovablePoint.WIDTH_HALF) && (cursorY <= this.y + MovablePoint.WIDTH_HALF)) {
            return true;
        }
        else {
            return false;
        }
    };
    MovablePoint.prototype.startDragging = function (cursorX, cursorY) {
        if ((cursorX >= this.x - MovablePoint.WIDTH_HALF) && (cursorX <= this.x + MovablePoint.WIDTH_HALF) &&
            (cursorY >= this.y - MovablePoint.WIDTH_HALF) && (cursorY <= this.y + MovablePoint.WIDTH_HALF)) {
            this.isDragging = true;
            return true;
        }
        else {
            return false;
        }
    };
    MovablePoint.prototype.stopDragging = function () {
        this.isDragging = false;
    };
    MovablePoint.prototype.cursorMoved = function (cursorX, cursorY) {
        if (this.isDragging) {
            this.x = cursorX;
            this.y = cursorY;
        }
    };
    MovablePoint.WIDTH_HALF = 5;
    return MovablePoint;
}());
//# sourceMappingURL=MovablePoint.js.map